@echo off
color 0A
echo ---------------------------------------------------------------
echo           BioStar 2.5 TNA Database Sync Tool
echo ---------------------------------------------------------------
echo. 
echo Caution: this tool was tested on BioStar 2.5. 
echo Your Biostar 2 should be using Maria DB (default) for this tool to work. 
echo.
echo. Please read the remarks below before proceeding:
echo.
echo. You must know your database admin ID and password to proceed.
echo. You must run this bat. file in the Server PC where Maria DB is installed. 
echo. You must run this bat. file with admin privileges. 
echo.
PAUSE
echo.
echo Enter the hard disk Volume you installed BioStar (example: C) 
set /p UserDrive=
echo.
:Ask
echo Is your BioStar installation type 32bit or 64bit? 
set INPUT=
echo.
set /P INPUT=Enter 32 or 64: %=%
If /I "%INPUT%"=="32" goto thirtytwobit
If /I "%INPUT%"=="64" goto sixtyfourbit
If /I "%INPUT%"=="32bit" goto thirtytwobit 
If /I "%INPUT%"=="64bit" goto sixtyfourbit

echo Incorrect input & goto Ask


:sixtyfourbit
echo What would you like to do? 
set INPUT=
echo.
echo 1. Reset device log synchronization 
echo 2. Reset TA registration (configuration remains) 
echo 3. Close Program
echo.

set /P INPUT= %=%
If /I "%INPUT%"=="1" goto SixtyFourDeviceSync
If /I "%INPUT%"=="2" goto SixtyFourTNASync
If /I "%INPUT%"=="3" goto GoodBye
echo Incorrect input & goto sixtyfourbit


:SixtyFourDeviceSync
echo. 
cd %UserDrive%:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin
echo. 
echo Trying to access BioStar 2 Database Directory........
echo.
echo Note: Your database ID was configured in the installation process of BioStar 2
echo.
echo Type in your Database ID (default is 'root') :
set /p UserID=
echo.
powershell -Command $pword = read-host "Enter password" -AsSecureString ; ^
    $BSTR=[System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($pword) ; ^
        [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) > .tmp.txt 
set /p UserPW=<.tmp.txt & del .tmp.txt

echo Resetting device sync date on devicesync table...(logs after 2017-06-01 will be synced again)
echo -----If any ERROR occurs, error message will appear below-----
mysql -h 127.0.0.1 -P 3312 --user=%UserID% --password=%UserPW% biostar_tna -e "START transaction; use biostar_tna; UPDATE `biostar_tna`.`eventsync` SET `last_query_end_datetime`='2017-06-01 00:00:00' WHERE  `id`!=0; UPDATE `biostar_tna`.`eventsync` SET `eddt`='2017-06-01 00:00:00' WHERE  `id`!=0; COMMIT;"
echo --------------------------------------------------------------
echo. 
echo Process complete
echo.
PAUSE
goto sixtyfourbit


:SixtyFourTNASync
echo. 
cd %UserDrive%:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin
echo. 
echo Trying to access BioStar 2 Database Directory........
echo.
echo Note: Your database ID was configured in the installation process of BioStar 2
echo.
echo Type in your Database ID (default is 'root') :
set /p UserID=
echo.
powershell -Command $pword = read-host "Enter password" -AsSecureString ; ^
    $BSTR=[System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($pword) ; ^
        [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) > .tmp.txt 
set /p UserPW=<.tmp.txt & del .tmp.txt

echo Resetting device sync date on devicesync table...(logs after 2017-06-01 will be synced again)
echo -----If any ERROR occurs, error message will appear below-----
mysql -h 127.0.0.1 -P 3312 --user=%UserID% --password=%UserPW% biostar_tna  -e "START transaction; use biostar_tna; UPDATE biostar_tna.systemsetting SET ext_system_session_id= null, ext_system_id= null, ext_sys_biostar_session_id = null, ext_sys_session_udt_datetime = null, last_udt_ver_for_user_sync = null WHERE id=1; COMMIT;"
echo --------------------------------------------------------------
echo. 
echo Process complete!
echo.
echo When you log in to BioStar 2, you will have to re-initialize TA in the TA menu. 
echo.
PAUSE
goto sixtyfourbit


REM    ******************************************** 32 BIT FROM HERE ****************************************


:thirtytwobit
echo What would you like to do? 
echo caution: 32 bit portion of this script hasn't been tested, but it should work. 

set INPUT=
echo.
echo 1. Reset device log synchronization 
echo 2. Reset TA registration (configuration remains) 
echo 3. Close Program
echo.

set /P INPUT= %=%
If /I "%INPUT%"=="1" goto ThirtyTwoDeviceSync
If /I "%INPUT%"=="2" goto ThirtyTwoTNASync
If /I "%INPUT%"=="3" goto GoodBye
echo Incorrect input & goto thirtytwobit



:ThirtyTwoDeviceSync
echo. 
cd %UserDrive%:\Program Files (x86)\BioStar 2\ta\mariadb-10.1.10-win32\bin
echo. 
echo Trying to access BioStar 2 Database Directory........
echo.
echo Note: Your database ID was configured in the installation process of BioStar 2
echo.
echo Type in your Database ID (default is 'root') :
set /p UserID=
echo.
powershell -Command $pword = read-host "Enter password" -AsSecureString ; ^
    $BSTR=[System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($pword) ; ^
        [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) > .tmp.txt 
set /p UserPW=<.tmp.txt & del .tmp.txt

echo Resetting device sync date on devicesync table...(logs after 2017-06-01 will be synced again)
echo -----If any ERROR occurs, error message will appear below-----
mysql -h 127.0.0.1 -P 3312 --user=%UserID% --password=%UserPW% biostar_tna -e "START transaction; use biostar_tna; UPDATE `biostar_tna`.`eventsync` SET `last_query_end_datetime`='2017-06-01 00:00:00' WHERE  `id`!=0; UPDATE `biostar_tna`.`eventsync` SET `eddt`='2017-06-01 00:00:00' WHERE  `id`!=0; COMMIT;"
echo --------------------------------------------------------------
echo. 
echo Process complete
echo.
PAUSE
goto thirtytwobit


:ThirtyTwoTNASync
echo. 
cd %UserDrive%:\Program Files (x86)\BioStar 2\ta\mariadb-10.1.10-win32\bin
echo. 
echo Trying to access BioStar 2 Database Directory........
echo.
echo Note: Your database ID was configured in the installation process of BioStar 2
echo.
echo Type in your Database ID (default is 'root') :
set /p UserID=
echo.
powershell -Command $pword = read-host "Enter password" -AsSecureString ; ^
    $BSTR=[System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($pword) ; ^
        [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) > .tmp.txt 
set /p UserPW=<.tmp.txt & del .tmp.txt

echo Resetting device sync date on devicesync table...(logs after 2017-06-01 will be synced again)
echo -----If any ERROR occurs, error message will appear below-----
mysql -h 127.0.0.1 -P 3312 --user=%UserID% --password=%UserPW% biostar_tna  -e "START transaction; use biostar_tna; UPDATE biostar_tna.systemsetting SET ext_system_session_id= null, ext_system_id= null, ext_sys_biostar_session_id = null, ext_sys_session_udt_datetime = null, last_udt_ver_for_user_sync = null WHERE id=1; COMMIT;"
echo --------------------------------------------------------------
echo. 
echo Process complete!
echo.
echo When you log in to BioStar 2, you will have to re-initialize TA in the TA menu. 
PAUSE
echo.
goto thirtytwobit

:GoodBye
exit






